<template>
  <div class="relative w-72 max-w-full">
    <div
      class="absolute inset-y-0 right-0 z-50 flex cursor-pointer items-center px-3 py-1 text-sm text-gray-300 hover:text-gray-400"
      @click="copyText()"
    >
      <UIcon name="i-heroicons-document-duplicate" class="h-5 w-5" />
    </div>
    <input
      ref="copyInputField"
      style="backdrop-filter: blur(4px)"
      :value="value"
      class="font-mono h-full w-full appearance-none rounded border-2 border-dashed border-gray-200 bg-transparent px-3 py-3 pr-16 leading-tight focus:outline-none"
      type="text"
      readonly
    />
  </div>
</template>

<script lang="ts" setup>
const props = defineProps({
  value: {
    type: String,
    required: true,
  },
});

const copyInputField = ref<HTMLInputElement | null>(null);

async function copyText() {
  const copyText = copyInputField.value as HTMLInputElement;
  // There is no need to select the text with the clipboard API, but we'll leave it
  // As visual feedback
  copyText.select();
  copyText.setSelectionRange(0, 99999); /* For mobile devices */
  try {
    await navigator.clipboard.writeText(props.value);
  } catch {
    document.execCommand("copy");
  }
  window.setTimeout(() => {
    copyText.blur();
    window.getSelection()?.removeAllRanges();
  }, 1000);
}
</script>
